#include <FK/FK.h>

const double	BUILDWIDTH	= 25.0;		// ̊{P
const double	SPEED		= 2.0;		// Ԃ̃Xs[h
const double	CIRCUITX	= 150.0;	// R[X X 
const double	CIRCUITY	= 250.0;	// R[X Y 
const double	EPS			= 0.001;	// 덷pl

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ԂɊւ鏈
void entryCar(fk_Scene &scene, fk_Model &bodyModel, fk_Model *tireModel, fk_Model *driverModel, bool viewFlag)
{
	scene.entryModel(&bodyModel);

	for(int i = 0; i < 4; i++) {
		scene.entryModel(&tireModel[i]);
	}

	scene.entryModel(&driverModel[0]);
	if(viewFlag == true) {
		scene.entryModel(&driverModel[1]);
	} else {
		scene.entryCamera(&driverModel[1]);
	}

	return;
}

void rotate(fk_Model *model, fk_Vector velocity, fk_Vector orgVec)
{
	// velocity  orgVec ̓ϒlA܂px 90 xȓ̏ꍇ]
	if(velocity * orgVec > EPS) {
		model->loAngle(FK_PI/100.0, 0.0, 0.0);
	}

	return;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// wiɊւ鏈
void entryWorld(fk_Scene &scene, fk_Model &groundModel, fk_Model *lightModel, fk_Model *buildModel, bool buildFlag)
{
	scene.entryModel(&groundModel);

	for(int i = 0; i < 2; i++) {
		scene.entryModel(&lightModel[i]);
	}

	for(int i = 0; i < 6; i++) {
		scene.entryModel(&buildModel[i]);
	}

	if(buildFlag == true) scene.removeModel(&buildModel[0]);

	return;
}

void defLight(fk_Model *lightModel, fk_Light &lightShape, int lightID, double x, double y, double z)
{
	lightModel[lightID].setShape(&lightShape);
	lightModel[lightID].setMaterial(White);
	lightModel[lightID].glTranslate(0.0, 0.0, 0.0);
	lightModel[lightID].glFocus(x, y, z);

	return;
}

void makeBuild(fk_Model *buildModel, fk_Block &buildShape, int buildID, double x, double y,
					  double heightScale, fk_Material *buildMat)
{
	buildModel[buildID].setShape(&buildShape);
	buildModel[buildID].setScale(heightScale, fk_Z);
	buildModel[buildID].glMoveTo(x, y, (BUILDWIDTH * heightScale)/2.0);
	buildModel[buildID].setMaterial(*buildMat);

	return;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int main(int, char *[])
{
	Fl_Window		mainWindow(940, 320, "FK TEST");
	fk_Scene		carViewScene, buildViewScene, birdViewScene;
	fk_Window		carViewWindow(10, 10, 300, 300);
	fk_Window		buildViewWindow(320, 10, 300, 300);
	fk_Window		birdViewWindow(630, 10, 300, 300);
	fk_Color		bgColor(0.2, 0.7, 1.0);

	fk_Model		buildViewModel, birdViewModel;

	// ԂɊւϐ
	fk_Model	carModel;		// ԑS̃f
	fk_Model	bodyModel;		// ԑ̃f
	fk_Model	tireModel[4];	// e^Cf
	fk_Model	driverModel[2];	// ^]҃f
	fk_Model	birdModel;		// Վ_f
	fk_Block	body;			// ԑ̌`
	fk_Circle	tire;			// ^C`
	fk_Sphere	driver;			// ^]Ҍ`

	// wiɊւϐ
	fk_Model	buildModel[6], groundModel, lightModel[2];
	fk_Block	buildShape, groundShape;
	fk_Light	lightShape;

	mainWindow.end();
	fk_Material::initDefault();

	// ԂɊւ鏈
	body.setSize(7.0, 6.0, 20.0);
	tire.setRadius(2.0);
	tire.setDivide(2);
	driver.setRadius(2.0);
	driver.setDivide(2);

	bodyModel.setShape(&body);
	bodyModel.glMoveTo(0.0, 5.0, 0.0);
	bodyModel.setMaterial(Yellow);
	bodyModel.setParent(&carModel);

	tireModel[0].glMoveTo(-4.0, 1.0, -8.0);
	tireModel[0].glVec(1.0, 0.0, 0.0);
	tireModel[1].glMoveTo(4.0, 1.0, -8.0);
	tireModel[1].glVec(-1.0, 0.0, 0.0);
	tireModel[2].glMoveTo(-4.0, 1.0, 8.0);
	tireModel[2].glVec(1.0, 0.0, 0.0);
	tireModel[3].glMoveTo(4.0, 1.0, 8.0);
	tireModel[3].glVec(-1.0, 0.0, 0.0);

	for(int i = 0; i < 4; i++) {
		tireModel[i].setShape(&tire);
		tireModel[i].setMaterial(Gray2);
		tireModel[i].setParent(&carModel);
	}

	driverModel[0].setShape(&driver);
	driverModel[1].setShape(&driver);
	driverModel[0].glMoveTo(-2.0, 10.0, 0.0);
	driverModel[1].glMoveTo(2.0, 10.0, 0.0);
	driverModel[0].setMaterial(Cream);
	driverModel[1].setMaterial(Cream);
	driverModel[0].setSmoothMode(true);
	driverModel[1].setSmoothMode(true);
	driverModel[0].setParent(&carModel);
	driverModel[1].setParent(&carModel);

	birdModel.glMoveTo(0.0, 100.0, 200.0);
	birdModel.glFocus(0.0, 5.0, 0.0);
	birdModel.glUpvec(0.0, 1.0, 0.0);
	birdModel.setParent(&carModel);

	carModel.glMoveTo(CIRCUITX, CIRCUITY, 0.0);
	carModel.glVec(0.0, -1.0, 0.0);
	carModel.glUpvec(0.0, 0.0, 1.0);
	// ܂

	// wiɊւ鏈
	// Ɩ̐ݒ
	defLight(lightModel, lightShape, 0, 1.0, 1.0, -1.0);
	defLight(lightModel, lightShape, 1, -1.0, -1.0, -1.0);
	// ̐ݒ
	buildShape.setSize(BUILDWIDTH, BUILDWIDTH, BUILDWIDTH);
	makeBuild(buildModel, buildShape, 0, -250.0, 100.0, 5.0, &Red);
	makeBuild(buildModel, buildShape, 1, -150.0, 400.0, 2.0, &DimYellow);
	makeBuild(buildModel, buildShape, 2, 50.0, 250.0, 4.0, &Blue); 
	makeBuild(buildModel, buildShape, 3, 300.0, 200.0, 3.0, &Gray1); 
	makeBuild(buildModel, buildShape, 4, 250.0, -250.0, 0.5, &Green);
	makeBuild(buildModel, buildShape, 5, -50.0, -350.0, 6.0, &Orange);
	// nʂ̐ݒ
	groundShape.setSize(1000, 1000, 2.0);
	groundModel.setShape(&groundShape);
	groundModel.glTranslate(0.0, 0.0, -1.0);
	groundModel.setMaterial(Brown);
	// ܂

	// eEBhEɃobNOEhJ[ݒ
	carViewScene.setBGColor(bgColor);
	buildViewScene.setBGColor(bgColor);
	birdViewScene.setBGColor(bgColor);

	// effBXvCXgɓo^
	entryWorld(carViewScene, groundModel, lightModel, buildModel, false);
	entryWorld(buildViewScene, groundModel, lightModel, buildModel, true);
	entryWorld(birdViewScene, groundModel, lightModel, buildModel, false);

	entryCar(carViewScene, bodyModel, tireModel, driverModel, false);
	entryCar(buildViewScene, bodyModel, tireModel, driverModel, true);
	entryCar(birdViewScene, bodyModel, tireModel, driverModel, true);

	// EBhE̎_ݒ
	buildViewModel.glMoveTo(-250.0, 100.0, 100.0);
	buildViewModel.glFocus(carModel.getPosition());
	buildViewModel.glUpvec(0.0, 0.0, 1.0);
	buildViewScene.entryCamera(&buildViewModel);

	// ՃEBhE̎_ݒ
	birdViewScene.entryCamera(&birdModel);

	// EBhEփfBXvCXgo^
	carViewWindow.setScene(&carViewScene);
	buildViewWindow.setScene(&buildViewScene);
	birdViewWindow.setScene(&birdViewScene);

	mainWindow.show();
	carViewWindow.show();
	buildViewWindow.show();
	birdViewWindow.show();

	while(true) {

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(carViewWindow.drawWindow() == 0 ||
		   buildViewWindow.drawWindow() == 0 ||
		   birdViewWindow.drawWindow() == 0) break;

		if(Fl::check() == 0) break;

		if(carViewWindow.winOpenStatus() == false ||
		   buildViewWindow.winOpenStatus() == false ||
		   birdViewWindow.winOpenStatus() == false) {
			continue;
		}	  

		/////////////////////////////////////////////////////////////////////
		fk_Vector	carPosition, carVelocity;
		fk_Vector	Xplus(1.0, 0.0, 0.0), Xminus(-1.0, 0.0, 0.0);
		fk_Vector	Yplus(0.0, 1.0, 0.0), Yminus(0.0, -1.0, 0.0);
		double		X = CIRCUITX;
		double		Y = CIRCUITY;

		carPosition = carModel.getPosition();
		carVelocity = carModel.getVec();
		carModel.loTranslate(0.0, 0.0, -SPEED); // Oi

		// T[Lbg̊OɂłꍇA]B
		if(carPosition.x > X) {
			rotate(&carModel, carVelocity, Xplus);
		}
		if(carPosition.x < -X) {
			rotate(&carModel, carVelocity, Xminus);
		}
		if(carPosition.y > Y) {
			rotate(&carModel, carVelocity, Yplus);
		}
		if(carPosition.y < -Y) {
			rotate(&carModel, carVelocity, Yminus);
		}
		/////////////////////////////////////////////////////////////////////

		buildViewModel.glFocus(carModel.getPosition());
		buildViewModel.glUpvec(0.0, 0.0, 1.0);
	}
	
	return 0;
}
