#include "TripleWindow.h"

TripleWindow::TripleWindow(void) :
	mainWindow(940, 320, "FK TEST"),
	carViewWindow(10, 10, 300, 300),
	buildViewWindow(320, 10, 300, 300),
	birdViewWindow(630, 10, 300, 300),
	bgColor(0.2, 0.7, 1.0)
{
	// EBhEƃVXȅ
	mainWindow.end();
	fk_Material::initDefault();

	// eEBhEɃobNOEhJ[ݒ
	carViewScene.setBGColor(bgColor);
	buildViewScene.setBGColor(bgColor);
	birdViewScene.setBGColor(bgColor);

	// EBhEփfBXvCXgo^
	carViewWindow.setScene(&carViewScene);
	buildViewWindow.setScene(&buildViewScene);
	birdViewWindow.setScene(&birdViewScene);

	// EBhE̕\
	mainWindow.show();
	carViewWindow.show();
	buildViewWindow.show();
	birdViewWindow.show();

	return;
}

TripleWindow::~TripleWindow(void)
{
}

bool TripleWindow::draw(void)
{
	while(true) {
		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				return false;
			} else {
				continue;
			}
		}

		if(carViewWindow.drawWindow() == 0 ||
		   buildViewWindow.drawWindow() == 0 ||
		   birdViewWindow.drawWindow() == 0) return false;

		if(Fl::check() == 0) return false;

		if(carViewWindow.winOpenStatus() == false ||
		   buildViewWindow.winOpenStatus() == false ||
		   birdViewWindow.winOpenStatus() == false) {
			continue;
		}

		return true;
	}
	// ɂ͗Ȃ͂ǔÔ
	return true;
}

void TripleWindow::updateView(Car *argCar)
{
	// _̒Ǐ]
	buildViewModel.glFocus(argCar->getCarPosition());
	buildViewModel.glUpvec(0.0, 0.0, 1.0);

	return;
}

void TripleWindow::entryCar(Car *argCar)
{
	// effBXvCXgɓo^
	argCar->entryScene(&carViewScene, false);
	argCar->entryScene(&buildViewScene, true);
	argCar->entryScene(&birdViewScene, true);

	// EBhE̎_ݒ
	buildViewModel.glMoveTo(-250.0, 100.0, 100.0);
	updateView(argCar);
	buildViewScene.entryCamera(&buildViewModel);

	// ՃEBhE̎_ݒ
	birdViewScene.entryCamera(argCar->getBirdModel());

	return;
}

void TripleWindow::entryWorld(World *argWorld)
{
	// effBXvCXgɓo^
	argWorld->entryScene(&carViewScene, false);
	argWorld->entryScene(&buildViewScene, true);
	argWorld->entryScene(&birdViewScene, false);

	return;
}

