#include "World.h"


World::World(void)
{
	init();

	return;
}

void World::defLight(int lightID, double x, double y, double z)
{
	lightModel[lightID].setShape(&lightShape);
	lightModel[lightID].setMaterial(White);
	lightModel[lightID].glTranslate(0.0, 0.0, 0.0);
	lightModel[lightID].glFocus(x, y, z);

	return;
}

void World::makeBuild(int buildID, double x, double y,
					  double heightScale, fk_Material *buildMat)
{
	buildModel[buildID].setShape(&buildShape);
	buildModel[buildID].setScale(heightScale, fk_Z);
	buildModel[buildID].glMoveTo(x, y, (BUILDWIDTH * heightScale)/2.0);
	buildModel[buildID].setMaterial(*buildMat);

	return;
}

void World::init(void)
{
	// Ɩ̐ݒ
	defLight(0, 1.0, 1.0, -1.0);
	defLight(1, -1.0, -1.0, -1.0);

	// ̐ݒ
	buildShape.setSize(BUILDWIDTH, BUILDWIDTH, BUILDWIDTH);
	makeBuild(0, -250.0, 100.0, 5.0, &Red);
	makeBuild(1, -150.0, 400.0, 2.0, &DimYellow);
	makeBuild(2, 50.0, 250.0, 4.0, &Blue); 
	makeBuild(3, 300.0, 200.0, 3.0, &Gray1); 
	makeBuild(4, 250.0, -250.0, 0.5, &Green);
	makeBuild(5, -50.0, -350.0, 6.0, &Orange);

	// nʂ̐ݒ
	groundShape.setSize(1000, 1000, 2.0);
	groundModel.setShape(&groundShape);
	groundModel.glTranslate(0.0, 0.0, -1.0);
	groundModel.setMaterial(Brown);

	return;
}

void World::entryScene(fk_Scene *scene, bool buildFlag)
{
	int		i;

	scene->entryModel(&groundModel);

	for(i = 0; i < 2; i++) {
		scene->entryModel(&lightModel[i]);
	}

	for(i = 0; i < 6; i++) {
		scene->entryModel(&buildModel[i]);
	}

	if(buildFlag == true) scene->removeModel(&buildModel[0]);
	return;
}
